'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var React = require('react');
var utilsCommons = require('@highlight-ui/utils-commons');
var dragAndDrop = require('@highlight-ui/drag-and-drop');
var classnames = require('classnames');
var typography = require('@highlight-ui/typography');
var icon = require('@highlight-ui/icon');
var checkbox = require('@highlight-ui/checkbox');
function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}
function __spreadArray(to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
}
var styles$4 = {
  "container": "CollapsibleRaw-module__eTrxVM3K__v4-0-3",
  "disabled": "CollapsibleRaw-module__ngMxWP6e__v4-0-3",
  "flex": "CollapsibleRaw-module__qIe0siOy__v4-0-3",
  "togglerWrapper": "CollapsibleRaw-module__6GQUfd5Q__v4-0-3",
  "togglerWrapperCursor": "CollapsibleRaw-module__CSECu2NG__v4-0-3",
  "contentWrapper": "CollapsibleRaw-module__lM7r8EL1__v4-0-3"
};
var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

/**
 * lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */

/** Used as the `TypeError` message for "Functions" methods. */
var FUNC_ERROR_TEXT = 'Expected a function';

/** Used as references for various `Number` constants. */
var NAN = 0 / 0;

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/** Used to match leading and trailing whitespace. */
var reTrim = /^\s+|\s+$/g;

/** Used to detect bad signed hexadecimal string values. */
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

/** Used to detect binary string values. */
var reIsBinary = /^0b[01]+$/i;

/** Used to detect octal string values. */
var reIsOctal = /^0o[0-7]+$/i;

/** Built-in method references without a dependency on `root`. */
var freeParseInt = parseInt;

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max,
  nativeMin = Math.min;

/**
 * Gets the timestamp of the number of milliseconds that have elapsed since
 * the Unix epoch (1 January 1970 00:00:00 UTC).
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Date
 * @returns {number} Returns the timestamp.
 * @example
 *
 * _.defer(function(stamp) {
 *   console.log(_.now() - stamp);
 * }, _.now());
 * // => Logs the number of milliseconds it took for the deferred invocation.
 */
var now = function () {
  return root.Date.now();
};

/**
 * Creates a debounced function that delays invoking `func` until after `wait`
 * milliseconds have elapsed since the last time the debounced function was
 * invoked. The debounced function comes with a `cancel` method to cancel
 * delayed `func` invocations and a `flush` method to immediately invoke them.
 * Provide `options` to indicate whether `func` should be invoked on the
 * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
 * with the last arguments provided to the debounced function. Subsequent
 * calls to the debounced function return the result of the last `func`
 * invocation.
 *
 * **Note:** If `leading` and `trailing` options are `true`, `func` is
 * invoked on the trailing edge of the timeout only if the debounced function
 * is invoked more than once during the `wait` timeout.
 *
 * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
 * until to the next tick, similar to `setTimeout` with a timeout of `0`.
 *
 * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
 * for details over the differences between `_.debounce` and `_.throttle`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to debounce.
 * @param {number} [wait=0] The number of milliseconds to delay.
 * @param {Object} [options={}] The options object.
 * @param {boolean} [options.leading=false]
 *  Specify invoking on the leading edge of the timeout.
 * @param {number} [options.maxWait]
 *  The maximum time `func` is allowed to be delayed before it's invoked.
 * @param {boolean} [options.trailing=true]
 *  Specify invoking on the trailing edge of the timeout.
 * @returns {Function} Returns the new debounced function.
 * @example
 *
 * // Avoid costly calculations while the window size is in flux.
 * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
 *
 * // Invoke `sendMail` when clicked, debouncing subsequent calls.
 * jQuery(element).on('click', _.debounce(sendMail, 300, {
 *   'leading': true,
 *   'trailing': false
 * }));
 *
 * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
 * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
 * var source = new EventSource('/stream');
 * jQuery(source).on('message', debounced);
 *
 * // Cancel the trailing debounced invocation.
 * jQuery(window).on('popstate', debounced.cancel);
 */
function debounce(func, wait, options) {
  var lastArgs,
    lastThis,
    maxWait,
    result,
    timerId,
    lastCallTime,
    lastInvokeTime = 0,
    leading = false,
    maxing = false,
    trailing = true;
  if (typeof func != 'function') {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  wait = toNumber(wait) || 0;
  if (isObject(options)) {
    leading = !!options.leading;
    maxing = 'maxWait' in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = 'trailing' in options ? !!options.trailing : trailing;
  }
  function invokeFunc(time) {
    var args = lastArgs,
      thisArg = lastThis;
    lastArgs = lastThis = undefined;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }
  function leadingEdge(time) {
    // Reset any `maxWait` timer.
    lastInvokeTime = time;
    // Start the timer for the trailing edge.
    timerId = setTimeout(timerExpired, wait);
    // Invoke the leading edge.
    return leading ? invokeFunc(time) : result;
  }
  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime,
      timeSinceLastInvoke = time - lastInvokeTime,
      result = wait - timeSinceLastCall;
    return maxing ? nativeMin(result, maxWait - timeSinceLastInvoke) : result;
  }
  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime,
      timeSinceLastInvoke = time - lastInvokeTime;

    // Either this is the first call, activity has stopped and we're at the
    // trailing edge, the system time has gone backwards and we're treating
    // it as the trailing edge, or we've hit the `maxWait` limit.
    return lastCallTime === undefined || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
  }
  function timerExpired() {
    var time = now();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    // Restart the timer.
    timerId = setTimeout(timerExpired, remainingWait(time));
  }
  function trailingEdge(time) {
    timerId = undefined;

    // Only invoke if we have `lastArgs` which means `func` has been
    // debounced at least once.
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = undefined;
    return result;
  }
  function cancel() {
    if (timerId !== undefined) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = undefined;
  }
  function flush() {
    return timerId === undefined ? result : trailingEdge(now());
  }
  function debounced() {
    var time = now(),
      isInvoking = shouldInvoke(time);
    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;
    if (isInvoking) {
      if (timerId === undefined) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        // Handle invocations in a tight loop.
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === undefined) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel;
  debounced.flush = flush;
  return debounced;
}

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return !!value && (type == 'object' || type == 'function');
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return !!value && typeof value == 'object';
}

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' || isObjectLike(value) && objectToString.call(value) == symbolTag;
}

/**
 * Converts `value` to a number.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {number} Returns the number.
 * @example
 *
 * _.toNumber(3.2);
 * // => 3.2
 *
 * _.toNumber(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toNumber(Infinity);
 * // => Infinity
 *
 * _.toNumber('3.2');
 * // => 3.2
 */
function toNumber(value) {
  if (typeof value == 'number') {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject(value)) {
    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
    value = isObject(other) ? other + '' : other;
  }
  if (typeof value != 'string') {
    return value === 0 ? value : +value;
  }
  value = value.replace(reTrim, '');
  var isBinary = reIsBinary.test(value);
  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
}
var lodash_debounce = debounce;
function useDynamicHeight(observeElement) {
  var _a = React.useState(0),
    height = _a[0],
    setHeight = _a[1];
  React.useLayoutEffect(function () {
    setHeight(observeElement ? observeElement.scrollHeight : 0);
    var debouncedResizeHandler = lodash_debounce(function () {
      setHeight(observeElement ? observeElement.scrollHeight : 0);
    }, 100);
    var mutationObserver = new MutationObserver(function () {
      setHeight(observeElement ? observeElement.scrollHeight : 0);
    });
    var resizeObserver = new ResizeObserver(function () {
      debouncedResizeHandler();
    });
    if (observeElement) {
      mutationObserver.observe(observeElement, {
        childList: true,
        subtree: true
      });
      resizeObserver.observe(observeElement);
    }
    return function () {
      mutationObserver.disconnect();
      resizeObserver.disconnect();
    };
  }, [observeElement]);
  return height;
}
var Collapsible = function (_a) {
  var _b, _c;
  var action = _a.action,
    children = _a.children,
    className = _a.className,
    _d = _a.classNames,
    classNames = _d === void 0 ? {
      toggler: '',
      togglerComponent: '',
      contentWrapper: ''
    } : _d,
    tabIndex = _a.tabIndex,
    _e = _a.disabled,
    disabled = _e === void 0 ? false : _e,
    metadata = _a.metadata,
    togglerComponent = _a.togglerComponent,
    _f = _a.initiallyExpanded,
    initiallyExpanded = _f === void 0 ? false : _f,
    onExpansionChange = _a.onExpansionChange;
  var _g = React.useState(initiallyExpanded),
    isExpanded = _g[0],
    setIsExpanded = _g[1];
  var _h = React.useState(),
    contentElement = _h[0],
    setContentElement = _h[1];
  var containerRef = React.useRef();
  // this hook must be here to support dynamic response to content DOM manipulations
  var contentHeight = useDynamicHeight(contentElement);
  React.useEffect(function () {
    setIsExpanded(initiallyExpanded);
  }, [initiallyExpanded]);
  var toggleCollapsible = function () {
    if (disabled) return;
    setIsExpanded(function (prevIsExpanded) {
      return !prevIsExpanded;
    });
    if (onExpansionChange) {
      onExpansionChange(!isExpanded);
    }
  };
  var isSpaceOrEnter = function (e) {
    return [' ', 'Enter'].includes(e.key);
  };
  var isContainerTargeted = function (e) {
    return e.target === containerRef.current;
  };
  return React__default["default"].createElement("div", __assign({
    className: classnames__default["default"](styles$4.container, (_b = {}, _b[styles$4.disabled] = disabled, _b), className)
  }, utilsCommons.parseMetadata(metadata), {
    "aria-expanded": String(isExpanded)
  }, typeof tabIndex !== 'undefined' ? {
    tabIndex: tabIndex
  } : {}, {
    role: "button",
    onKeyDown: function (e) {
      return isSpaceOrEnter(e) && isContainerTargeted(e) && e.preventDefault();
    },
    onKeyUp: function (e) {
      return isSpaceOrEnter(e) && toggleCollapsible();
    },
    ref: containerRef
  }), React__default["default"].createElement("div", {
    className: classnames__default["default"](styles$4.flex, classNames.toggler)
  }, React__default["default"].createElement("div", {
    className: classnames__default["default"](styles$4.togglerWrapper, classNames.togglerComponent, (_c = {}, _c[styles$4.togglerWrapperCursor] = !disabled, _c)),
    onClick: toggleCollapsible,
    role: "button"
  }, togglerComponent), action), React__default["default"].createElement("fieldset", {
    className: classnames__default["default"](styles$4.contentWrapper, classNames.contentWrapper),
    style: {
      maxHeight: isExpanded ? contentHeight : 0
    },
    ref: setContentElement,
    role: "presentation",
    onKeyUp: function (e) {
      return e.stopPropagation();
    },
    disabled: !isExpanded
  }, children));
};
var styles$3 = {
  "title": "AccordionSectionTitle-module__I9lo5N6A__v4-0-3",
  "titleArrow": "AccordionSectionTitle-module__yB8fFJ-l__v4-0-3",
  "checkBoxWrapper": "AccordionSectionTitle-module__jN1I2mjR__v4-0-3",
  "checkBox": "AccordionSectionTitle-module__HBhjIOCu__v4-0-3"
};
var AccordionSectionTitle = function AccordionSectionTitle(_a) {
  var _b = _a.disabled,
    disabled = _b === void 0 ? false : _b,
    section = _a.section,
    selectable = _a.selectable,
    _c = _a.selectedSections,
    selectedSections = _c === void 0 ? [] : _c,
    _d = _a.onSelectedSectionsChange,
    onSelectedSectionsChange = _d === void 0 ? utilsCommons.noop : _d,
    dragRef = _a.dragRef;
  var handleOnCheck = function (e) {
    var isChecked = e.target.checked;
    var newList = isChecked ? __spreadArray(__spreadArray([], selectedSections, true), [section], false) : selectedSections.filter(function (sec) {
      return sec.key !== section.key;
    });
    onSelectedSectionsChange(newList);
  };
  var accordionSectionLabel = typeof section.title === 'string' ? React__default["default"].createElement(typography.Typography, {
    component: "span",
    token: "heading-small"
  }, section.title) : React__default["default"].createElement(React__default["default"].Fragment, null, section.title);
  return React__default["default"].createElement("div", {
    className: styles$3.title
  }, dragRef && React__default["default"].createElement(dragAndDrop.DragIcon, {
    dragRef: dragRef,
    disabled: disabled
  }), React__default["default"].createElement(icon.Icon, {
    name: "angle-down",
    size: 16,
    type: "solid",
    color: disabled ? 'icon-disabled' : 'icon-subdued',
    className: styles$3.titleArrow
  }), selectable &&
  // eslint-disable-next-line jsx-a11y/no-static-element-interactions
  React__default["default"].createElement("div", {
    className: styles$3.checkBoxWrapper,
    onClick: function (e) {
      return e.stopPropagation();
    },
    onKeyUp: function (e) {
      return e.stopPropagation();
    }
  }, React__default["default"].createElement(checkbox.Checkbox, {
    checked: selectedSections.some(function (sec) {
      return sec.key === section.key;
    }),
    readOnly: true,
    onChange: handleOnCheck,
    className: styles$3.checkBox,
    disabled: disabled
  })), accordionSectionLabel);
};
var styles$2 = {
  "section": "AccordionSectionItem-module__HCAa-QkL__v4-0-3",
  "sectionActions": "AccordionSectionItem-module__L6oxClCj__v4-0-3",
  "sectionToggler": "AccordionSectionItem-module__rqNXVa2o__v4-0-3",
  "sectionTogglerComponent": "AccordionSectionItem-module__BTg2vLgH__v4-0-3",
  "sectionContent": "AccordionSectionItem-module__lLDcZ7rt__v4-0-3"
};
var AccordionSectionItem = function (_a) {
  var _b, _c;
  var dragRef = _a.dragRef,
    section = _a.section,
    selectable = _a.selectable,
    onSelectedSectionsChange = _a.onSelectedSectionsChange,
    selectedSections = _a.selectedSections,
    initiallyExpanded = _a.initiallyExpanded,
    onExpansionChange = _a.onExpansionChange;
  return React__default["default"].createElement(Collapsible, __assign({}, section.actions ? {
    action: React__default["default"].createElement("fieldset", {
      disabled: section.disabled,
      className: classnames__default["default"]((_b = {}, _b[styles$2.sectionActions] = section.actions, _b)),
      role: "presentation",
      onKeyUp: function (e) {
        return e.stopPropagation();
      }
    }, section.actions)
  } : {}, {
    disabled: section.disabled,
    className: styles$2.section,
    classNames: {
      toggler: styles$2.sectionToggler,
      togglerComponent: styles$2.sectionTogglerComponent
    }
  }, section.disabled ? {} : {
    tabIndex: 0
  }, {
    togglerComponent: React__default["default"].createElement(AccordionSectionTitle, {
      dragRef: dragRef,
      disabled: section.disabled,
      section: section,
      selectable: selectable,
      onSelectedSectionsChange: onSelectedSectionsChange,
      selectedSections: selectedSections
    }),
    initiallyExpanded: initiallyExpanded,
    onExpansionChange: onExpansionChange,
    metadata: section.metadata
  }), React__default["default"].createElement("div", {
    className: classnames__default["default"](styles$2.sectionContent, (_c = {}, _c[styles$2.selectable] = selectable, _c))
  }, section.content));
};
var defaultInitiallyOpen$1 = [];
var defaultSelectedSections$1 = [];
var DraggableAccordionWithRef = function AccordionMultiple(_a, ref) {
  var className = _a.className,
    _b = _a.initiallyOpen,
    initiallyOpen = _b === void 0 ? defaultInitiallyOpen$1 : _b,
    _c = _a.multiple,
    multiple = _c === void 0 ? false : _c,
    metadata = _a.metadata,
    onSelectedSectionsChange = _a.onSelectedSectionsChange,
    sections = _a.sections,
    _d = _a.selectable,
    selectable = _d === void 0 ? false : _d,
    _e = _a.selectedSections,
    selectedSections = _e === void 0 ? defaultSelectedSections$1 : _e,
    dragProps = _a.dragProps,
    onExpansionChange = _a.onExpansionChange;
  var openKeys = React.useMemo(function () {
    var firstKey = initiallyOpen.length ? [initiallyOpen[0].key] : [];
    return multiple ? initiallyOpen.map(function (_a) {
      var key = _a.key;
      return key;
    }) : firstKey;
  }, [initiallyOpen, multiple]);
  var _f = React.useState(openKeys),
    openSections = _f[0],
    setOpenSections = _f[1];
  var expansionChangeHandler = React.useCallback(function (item, index) {
    return function (isExpanded) {
      if (onExpansionChange) {
        onExpansionChange(item, isExpanded, index);
      }
      if (multiple === false) {
        setOpenSections(openSections.includes(item.key) ? [] : [item.key]);
      }
    };
  }, [multiple, onExpansionChange, openSections]);
  React.useEffect(function () {
    setOpenSections(openKeys);
  }, [openKeys]);
  return React__default["default"].createElement("div", __assign({
    ref: ref,
    className: className
  }, utilsCommons.parseMetadata(metadata)), React__default["default"].createElement(dragAndDrop.DragAndDropList, {
    list: sections,
    dragProps: dragProps,
    renderItem: function (_a) {
      var section = _a.item,
        index = _a.index,
        dragRef = _a.dragRef;
      return React__default["default"].createElement(AccordionSectionItem, {
        dragRef: dragRef,
        section: section,
        selectable: selectable,
        initiallyExpanded: openSections.includes(section.key),
        onExpansionChange: expansionChangeHandler(section, index),
        onSelectedSectionsChange: onSelectedSectionsChange,
        selectedSections: selectedSections
      });
    }
  }));
};
DraggableAccordionWithRef.displayName = 'DraggableAccordion';
var DraggableAccordion = React__default["default"].forwardRef(DraggableAccordionWithRef);
var styles$1 = {
  "list": "StaticAccordion-module__Psf6bsX3__v4-0-3"
};
var defaultInitiallyOpen = [];
var defaultSelectedSections = [];
var StaticAccordionWithRef = function AccordionMultiple(_a, ref) {
  var className = _a.className,
    _b = _a.initiallyOpen,
    initiallyOpen = _b === void 0 ? defaultInitiallyOpen : _b,
    _c = _a.multiple,
    multiple = _c === void 0 ? false : _c,
    metadata = _a.metadata,
    onSelectedSectionsChange = _a.onSelectedSectionsChange,
    sections = _a.sections,
    _d = _a.selectable,
    selectable = _d === void 0 ? false : _d,
    _e = _a.selectedSections,
    selectedSections = _e === void 0 ? defaultSelectedSections : _e,
    onExpansionChange = _a.onExpansionChange;
  var openKeys = React.useMemo(function () {
    var firstKey = initiallyOpen.length ? [initiallyOpen[0].key] : [];
    return multiple ? initiallyOpen.map(function (_a) {
      var key = _a.key;
      return key;
    }) : firstKey;
  }, [initiallyOpen, multiple]);
  var _f = React.useState(openKeys),
    openSections = _f[0],
    setOpenSections = _f[1];
  var expansionChangeHandler = React.useCallback(function (item, index) {
    return function (isExpanded) {
      if (onExpansionChange) {
        onExpansionChange(item, isExpanded, index);
      }
      if (multiple === false) {
        setOpenSections(openSections.includes(item.key) ? [] : [item.key]);
      }
    };
  }, [multiple, onExpansionChange, openSections]);
  React.useEffect(function () {
    setOpenSections(openKeys);
  }, [openKeys]);
  return React__default["default"].createElement("div", __assign({
    ref: ref,
    className: className
  }, utilsCommons.parseMetadata(metadata)), React__default["default"].createElement("ul", {
    className: styles$1.list
  }, sections.map(function (section, index) {
    return React__default["default"].createElement("li", {
      key: section.key
    }, React__default["default"].createElement(AccordionSectionItem, {
      section: section,
      selectable: selectable,
      initiallyExpanded: openSections.includes(section.key),
      onExpansionChange: expansionChangeHandler(section, index),
      onSelectedSectionsChange: onSelectedSectionsChange,
      selectedSections: selectedSections
    }));
  })));
};
StaticAccordionWithRef.displayName = 'StaticAccordion';
var StaticAccordion = React__default["default"].forwardRef(StaticAccordionWithRef);
var AccordionWithRef = function (_a, ref) {
  var dragProps = _a.dragProps,
    restProps = __rest(_a, ["dragProps"]);
  if (dragProps) {
    return React__default["default"].createElement(DraggableAccordion, __assign({
      ref: ref,
      dragProps: dragProps
    }, restProps));
  }
  return React__default["default"].createElement(StaticAccordion, __assign({
    ref: ref
  }, restProps));
};
var Accordion = React__default["default"].forwardRef(AccordionWithRef);
var styles = {
  "container": "Expandable-module__pOapgnkt__v4-0-3",
  "toggle": "Expandable-module__kyAjaYOL__v4-0-3",
  "icon": "Expandable-module__buPYYIlu__v4-0-3",
  "content": "Expandable-module__L-5zUjUX__v4-0-3",
  "toggleTitle": "Expandable-module__NFY7cehh__v4-0-3",
  "disabled": "Expandable-module__kbZ3LrNd__v4-0-3"
};
var Expandable = function (_a) {
  var _b;
  var title = _a.title,
    content = _a.content,
    className = _a.className,
    _c = _a.disabled,
    disabled = _c === void 0 ? false : _c,
    _d = _a.isInitiallyExpanded,
    isInitiallyExpanded = _d === void 0 ? false : _d,
    onExpansionChange = _a.onExpansionChange,
    metadata = _a.metadata;
  return React__default["default"].createElement(Collapsible, __assign({
    metadata: metadata,
    disabled: disabled,
    className: classnames__default["default"](styles.container, className),
    classNames: {
      togglerComponent: classnames__default["default"]((_b = {}, _b[styles.disabled] = disabled, _b))
    }
  }, disabled ? {} : {
    tabIndex: 0
  }, {
    togglerComponent: React__default["default"].createElement("div", {
      className: styles.toggle
    }, React__default["default"].createElement(icon.Icon, {
      className: styles.icon,
      type: "solid",
      name: "angle-down"
    }), React__default["default"].createElement(typography.Typography, {
      className: styles.toggleTitle,
      token: "heading-small",
      component: "span"
    }, title)),
    initiallyExpanded: isInitiallyExpanded,
    onExpansionChange: onExpansionChange
  }), React__default["default"].createElement(typography.Typography, {
    className: styles.content,
    token: "body-base",
    component: "div"
  }, content));
};
exports.Accordion = Accordion;
exports.DraggableAccordion = DraggableAccordion;
exports.Expandable = Expandable;
exports.StaticAccordion = StaticAccordion;
//# sourceMappingURL=index.js.map
