import React from 'react';
import { PropsWithMetadata } from '@highlight-ui/utils-commons';
export declare type ExpandableProps = PropsWithMetadata<{
    /** The string to show as the toggler */
    title: string;
    /** The component to mount in the expandable contents part */
    content: React.ReactNode;
    /** Sets the root element's class attribute */
    className?: string;
    /** Sets the toggle's class attribute */
    togglerClassName?: string;
    /** Should the component be non-interactive? */
    disabled?: boolean;
    /** Should the component be expanded by default? */
    isInitiallyExpanded?: boolean;
    /** Callback fired whenever the component opens or closes. */
    onExpansionChange?: (isExpanded: boolean) => void;
}>;
declare const Expandable: ({ title, content, className, disabled, isInitiallyExpanded, onExpansionChange, metadata, }: ExpandableProps) => JSX.Element;
export default Expandable;
